{ pkgs, ... }:

let
  PROJECT_ROOT = "/workspace/deployed-nixos-server-and-apps/nixos-apps/fancytypist.dev";
  PORT = "12513";
  HOST = "localhost";
in
{
  services.caddy = {
    enable = true;
    virtualHosts = {
      "fancytypist.com" = {
        serverAliases = [ "www.fancytypist.com" ];
        extraConfig = ''
          respond "Hello, world! fancytypist.com"
        '';
      };

      "fancytypist.ca" = {
        serverAliases = [ "www.fancytypist.ca" ];
        extraConfig = ''
          respond "Hello, world! fancytypist.ca"
        '';
      };

      "fancytypist.dev" = {
        serverAliases = [ "www.fancytypist.dev" ];
        extraConfig = ''
          reverse_proxy ${HOST}:${PORT}
        '';
      };
    };
  };

  systemd.services = {
    fancyTypistDotDev-site = {
      enable = true;
      description = "The Haskell Servant executable server that hosts my FancyTypist.dev site.";
      path = with pkgs; [ nix git ];
      script = ''
        cd ${PROJECT_ROOT}
        nix run .#fancyTypistDotDev-site
      '';
    };
  };
}
