{ pkgs, ... }:
let baseUrl = "paperless.ewanick.com";
in
{
  services.paperless = {
    enable = true;
    address = "localhost";
    port = 28981;
  };
  systemd.services.paperless-scheduler.after = [ "var-lib-paperless.mount" ];
  systemd.services.paperless-consumer.after = [ "var-lib-paperless.mount" ];
  systemd.services.paperless-web.after = [ "var-lib-paperless.mount" ];

  services.caddy = {
    enable = true;
    virtualHosts = {
      "${baseUrl}" = {
        extraConfig = ''
          reverse_proxy localhost:28981
        '';
      };
    };
  };
}
